<?php
require_once('config.php');
require_once("ReaderClass/class_c64reader.php");
set_time_limit(0);  // no time limit to finish script!

echo $html_begin;
echo "<fieldset style='width:600px;'><legend><b>Error report</b></legend>";
echo "<i>-show a detailed error report of a collection!</i><br><br>";
echo "<b>Directory:</b>".$internal_path;

 
$Lerror = array();              
$NUM_files_formated = 0;
$NUM_files_d64      = 0;
$NUM_files_error    = 0;
$NUM_disks          = 0;
$THIS_disk_no       = -1;
$LAST_disk_no       = -1;
$disk_has_error     = 0;
$NUM_disks_error    = 0;

function traversedir($path,$dir) 
  {
    global $Lerror;
    global $NUM_files_formated;
    global $NUM_files_error;
    global $NUM_files_d64;
    global $NUM_disks;
    global $THIS_disk_no; 
    global $LAST_disk_no; 
    global $disk_has_error; 
    global $NUM_disks_error;

    $dir_list = scandir($path.$dir);     
    for ($i=0;$i<sizeOf($dir_list);$i++)
    {
      $dir_entry = $dir_list[$i];
      if ($dir_entry != "." && $dir_entry != "..") 
      {
        if (is_dir($path.$dir.$dir_entry)) 
        {
          traversedir($path, $dir.$dir_entry.'/');
        }
        else if (is_file($path.$dir.$dir_entry)) 
        {
	       $filename = $path.$dir.$dir_entry;
	       $fp = fopen($filename,'r');
	       $file_size = filesize($filename);
	       if ( ( $file_size > 20 ) and ( $file_size < 2000000 ) )
	       {
            $file_extension = strtolower(substr(strrchr($dir_list[$i],"."),1));
             
            #echo NL . substr($dir_list[$i], 4, -5); # disk number {0,1,...,2435}
            #echo NL . substr($dir_list[$i], strlen($dir_list[$i])-5, 1); # disk side {a,b}
            
            if ($file_extension=='d64'){
              $NUM_files_d64++;
              $THIS_disk_no = substr($dir_list[$i], 0, -5);
              if ($THIS_disk_no<>$LAST_disk_no){
                $NUM_disks_error += $disk_has_error;
                $disk_has_error = 0;
              }
              
              # Count disk if we have a side A.
              if ( ( strtolower( substr($dir_list[$i], strlen($dir_list[$i])-5, 1) ) ) == 'a' ){
                $NUM_disks++;
              }
              
              if ($file_size == 174848)
              {
                $NUM_files_formated++; 
              }
              elseif($file_size == 175531)
              {                
                $file_data = fread($fp,$file_size);
                
                $formated = 0;
                for ($j=174848;$j<$file_size;$j++)
                { 
                  if (ord($file_data[$j])<>3){$formated=1;break;}
                }

                if ($formated==1){
                  for ($j=174848;$j<$file_size;$j++)
                  { 
                    $Lerror[ord($file_data[$j])]++;
                  }
                  $NUM_files_formated++; 
                  $NUM_files_error++;
                  $disk_has_error = 1;                  
                }
              }
              else
              {
                // echo "<br>$filename:<i>Unknown filesize...</i>";
              }
            $LAST_disk_no = $THIS_disk_no;  
            } # end d64           
            # ob_flush();flush();                      
         }
         fclose($fp);
        }   
        else
        {
          echo "Unknown!!!!!!! ".$dir.$dir_list[$i]."<br>";
        }
      }  
    } 
  }

  
    $dir_list = scandir(ARCHIVE_PATH);
    echo "<form name='form_add_pack' action='$PHP_SELF' method='post'>";
    echo "<input type='submit' name='tja' value='Examine'>";
    echo "<select name='sel_pack'>";
    echo "<option disabled >Chose pack to import</option>";
    echo "<option value='-1'><b>**all packs</b></option>";
    
    echo ARCHIVE_PATH."<br>";
    for ($i=0;$i<sizeOf($dir_list);$i++)
    {
      $dir_entry = $dir_list[$i];
      if ($dir_entry != "." && $dir_entry != "..") 
      {
        if (is_dir(ARCHIVE_PATH.$dir_entry)) 
        {
          echo "<option value=\"$dir_entry\">".$dir_entry."</option>";
        }
      }  
     }
    echo "</select>";
    echo "<br><br></form>";


$pack_name = (!empty($_REQUEST['sel_pack'])) ? $_REQUEST['sel_pack'] : null;
$find = (!empty($_REQUEST['tja'])) ? $_REQUEST['tja'] : null;


if ( ($pack_name) AND ($find) )
{
  $tid_start = getmicrotime();
  
  while (ob_get_level()) {
    ob_end_flush();
  }
  // start output buffering
  if (ob_get_length() === false) {
    ob_start();
  }
  
  if ($pack_name=='-1')
  {
  echo "<h2>ALL.....</h2>"; 
  $pack_name = "/";  
  $dir_list = scandir(ARCHIVE_PATH);
   for ($i=0;$i<sizeOf($dir_list);$i++)
   {
    $dir_entry = "";
    $dir_entry = $dir_list[$i];
    if ($dir_entry != "." && $dir_entry != ".." && (is_dir(ARCHIVE_PATH.$dir_entry)) )  
    {
     $pack_name = $dir_entry."/";
    }
      else
      {    
        traversedir(ARCHIVE_PATH,$pack_name);
        $pack_name = ''; 
        $dir_entry = '';
      }
    }
   }
    
  else
  {  
    $pack_name .= "/";  
    # echo ARCHIVE_PATH . $pack_name . "<br>";
    if (is_dir(ARCHIVE_PATH . $pack_name))
    {
        traversedir(ARCHIVE_PATH . $pack_name,'');
    }
    else
    {
      echo "<h3>not a valid dir $pack_name</h3>";  
    }  
  }
  
  $tid_slut = getmicrotime();
  
  echo "<fieldset style='width:380px;'><legend><b>Error report</b></legend>";
  echo "<br>";
  $pack_name[strlen($pack_name)-1] = ' ';
  $total_samples        = 0;
  $total_samples_errors = 0;
  $total_sectors        = $NUM_files_formated * 683; //683 sectors pr. d64 image 
  
  foreach ($Lerror as $key => $value){
    $total_samples += $value;    
    if ($key<>1){$total_samples_errors += $value;}
  }
  
  echo "<table border=1><tr><th colspan=4><h2 style='display:inline;'>$pack_name</h2></th></tr><tr><th style='background-color:#aaaaaa;'>Error-code</th><th style='background-color:#aaaaaa;'>Count</th><th style='background-color:#aaaaaa;'>%</th></tr>";
  foreach ($Lerror as $key => $value){
    echo "<tr><td align=center>".$key."</td>";
    echo "<td style='text-align:right;'>".number_format((int) $value)."</td>";
    echo "<td style='text-align:right;'>(".round((100*$value/$total_samples), 2)."%)</td></tr>";
  }  
  echo "</table>";
  
  echo "<br><b>Total number disks:</b> ".number_format($NUM_disks); 
  echo "<br><b>Total number of d64 files:</b> ".number_format($NUM_files_d64); 
  echo "<br><b>Total number of formated d64 files:</b> ".number_format($NUM_files_formated); 
  
  if ($NUM_disks_error>0){
    echo "<br><b>Total number of disks with errors:</b> ".number_format($NUM_disks_error)." (".round(100*$NUM_disks_error/$NUM_disks, 1)."%)";   
  }
  
  if ($NUM_files_formated>0){
    echo "<br><b>Total number of d64 files with errors:</b> ".number_format($NUM_files_error)." (".round(100*$NUM_files_error/$NUM_files_formated, 1)."%)"; 
    echo "<br><b>Total number of sectors with errors:</b> ".number_format($total_samples_errors)." (".round(100*$total_samples_errors/$total_sectors, 2)."%)"; 
  }
  echo "<p>Time used: ".gmdate('H:i:s', ($tid_slut-$tid_start)), "<br><form action=$PHP_SELF><input type=submit value='Ok'></form><hr>"; 
  echo "</fieldset>";
 }
?>

</body>
</html>

